Bug 1889 - Add Camera support to Flash plug-in.
: Add Camera support to Flash plug-in.
Product: Browser
Plug-ins: Flash
: unspecified
: All All
: Low enhancement with 54 votes (vote)
: ---
Assigned To: unassigned
: flash-bugs
: http://tabletblog.com/2007/08/feature...
: enhancement-it2007
  Show dependency tree
Reported: 2007-08-23 01:24 UTC by Daniel Gentleman
Modified: 2010-01-12 15:19 UTC (History)
7 users (show)

See Also:



You need to log in before you can comment on or make changes to this bug.

Description Daniel Gentleman (reporter) 2007-08-23 01:24:13 UTC
The URL provided above illustrates the advantages of adding the Camera support
to the Flash plug-in. Currently Microphone support already works, so this is
just a driver upgrade.

Camera support for the Flash plug-in will allow the Flash plug-in to upload or
stream video directly to sites like YouTube, uStream, and others.
Comment 1 Daniel Gentleman (reporter) 2007-08-23 07:20:23 UTC
To replicate the conditions: 
Go to any site that uses Flash for webcam access. I will use YouTube as an
Click "Upload" in the YouTube, fill out the description fields, and choose "Use
QuickCapture"  In the screen that follows in a webcam equipped PC, the user
will be asked for permission for the Flash player to use the webcam and
microphone. After permission is granted, the microphone is detected but the
webcam is not. Holding the stylus down on the Flash window and then choosing
Settings, then choosing the Webcam icon allows the user to select a webcam from
a list. On all my webcam-equipped computers, the webcams are listed. On the
N800, there is no option.
Comment 2 technut 2007-11-26 09:21:09 UTC
Lack of camera support in Flash is still an issue in OS2008.
Comment 3 Jason Carter 2007-11-27 03:29:19 UTC
Could possibly be that the features which allow you to stream from a camera
with flash is something that was removed from the version of Flash running on
our tablets. 

Secondly, it seems like just trying to take a simple picture can be too much
for the tablet to handle as camera, videocamera and knips all are VERY slow and
VERY crashy. There's no doubt in my mind that if this bug was fixed, it
wouldn't really be worthwhile anyways... unless your viewers enjoy Youtube
videos at 1 frame per 2.6 seconds.
Comment 4 technut 2007-11-27 06:22:23 UTC
(In reply to comment #3)

I wouldn't write it off so quickly.  It does decent tablet-to-tablet video
Comment 5 technut 2007-11-28 08:09:42 UTC
Comment added to enhancement request 1833 (N800 to PC video calls) to raise
awareness of the synergy that would come from adding webcam support in Flash.
Comment 6 technut 2007-11-28 13:23:48 UTC
I found a site for simple testing of Flash audio and video.
Create a short recording on the left-hand side, Save/replace it and then play
it back on the right-hand side.

As expected, the webcam is not supported.  But I also didn't get any good
audio, just a bit of noise.

I've done some research about the APIs being used by Flash Player 9 for A/V
input and here's what I found it is expecting:
# Audio I/O: ALSA
# Camera input: Video4Linux, API version 1

That is what we need to ask Nokia to support in their microphone and webcam
drivers.  Hopefully they are feeling generous.  :)
Comment 7 technut 2007-11-28 13:25:37 UTC
Sorry, the correct URL for the Flash testing site is:
Comment 8 timeless 2007-11-28 16:48:17 UTC
A little birdie told me that Flash relies on an open source library called

I have no idea where the official source for this library is, below are some

In theory it should be possible to find and build some version of
libflashsupport as a drop in replacement for a file by the same name in
/usr/lib, from there, all anyone in the maemo community has to do is "get
camera working with this library".

Note: this isn't a browser task. We don't have resources to do it. It's only
dumped in this component because there's no other place for it (corporate

Anyway, anyone interested is welcome to work on this. If you have questions
about how the library works, I'm not sure to whom they should be addressed.

This seems like a fairly good starting point as required reading:

    * You will notice additional code in flashsupport.c for GnuTLS,
      VideoForLinux1, and ALSA. These are not working in Adobe Flash Player
      9 beta 1 for Linux; they are provided for reference only. 

AFAIu, maemo uses or has a v4l implementation:

Note: the browser team has no knowledge of multimedia APIs, the best and only
support I can offer is cross referencing of modules.

As such, the following link should eventually be moderately useful (in
conjunction with the chinook link above):
Comment 9 technut 2007-11-29 12:01:17 UTC
(In reply to comment #8)
>     * You will notice additional code in flashsupport.c for GnuTLS,
>       VideoForLinux1, and ALSA. These are not working in Adobe Flash Player
>       9 beta 1 for Linux; they are provided for reference only. 

I believe this information is out of date.  The Flash version included with
OS2008 (per about:plugins) is 9.0.31 and the related release notes here:
section < Fixes and improvements in Flash Player Support for Linux >
states: "Only ALSA is supported for microphone input and speaker output, and
only Video4Linux v1 is supported for camera input."
This information should be moderately useful.
Comment 10 technut 2007-12-01 07:41:25 UTC
From my research, I believe ALSA and VFL1 are the default APIs in Flash Player  It looks like flashsupport.c is only required if you wish to use a
different API (eg. the most common use is for adding OpenSoundSystem audio

But in the event it is still needed, I found what looks to be the latest
version of flashsupport.c (rev 1.3) in a Sourceforge project that is maintained
by two Adobe Flash staff, here:
in the CVS repository here:

Note: I also discovered the latest build of Flash Player for Linux is,
but the only change was to address a security vulnerability.
Comment 11 timeless 2007-12-01 19:14:55 UTC
         if ( ( instance->v4l_fd = open("/dev/video", O_RDONLY) ) < 0 ) goto

the n810 only has /dev/video0, this won't work. try changing it :)
Comment 12 technut 2007-12-13 02:45:30 UTC
I don't code so I can't try the suggestion from Timeless myself, but I just
found this:
Maemo 4.x > How to Use Camera API

which says "The built-in camera present in some Nokia Internet Tablet devices
is compatible with Video-4-Linux version 2 API".

But Flash 9 is looking for a Video-4-Linux version 1 API.  So that may be an
Comment 13 Faheem Pervez maemo.org 2008-06-08 09:16:20 UTC
Flashcam here by tz1:

I was unable to test as my flash in diablo is different but it seems to be
working fine for the people on chinook.
Comment 14 Quim Gil nokia 2008-06-24 18:25:13 UTC
Hi, as for today productizing this feature as requested requires a significant
effort from our side. We have considered it but according to the current plans
we will not work on this for Fremantle. Undecided for Harmattan at this point.

If the feature itself comes through the Flash player owners, the community or a
different implementation, that is another thing.

I'm not sure what to do with this bug. WONTFIX until we have different plans?
LATER? Leave it as it is?
Comment 15 Andre Klapper maemo.org 2008-06-24 18:38:40 UTC
Quim: Just CC me when needed. :-)
If the devs decide to not work on this, it is WONTFIX to me (which means:
somebody could stand up and fix it, but it will not be the developer himself).
And "RESOLVED LATER" is something very very strange that just hides the fact
that no-one will work on it in the next time. I can only encourage everybody to
not use it. ;-)
Comment 16 Andre Klapper maemo.org 2009-09-07 12:18:32 UTC
(Split Plug-Ins into "Flash" and "Others", hence correcting QA Contact.
Sorry for the noise.)
Comment 17 timeless 2009-09-07 12:28:16 UTC
fwiw, for the n900, i was told that it was intentionally disabled. it was
actually technically working at one point (accidentally). among other things,
we're afraid of pages managing to get users to accidentally enable the camera
and the privacy concerns that entails.

note that i'd really love to see this feature, because i'd much rather use
Gmail for video than use the rest of the platform :). But....
Comment 18 Andre Klapper maemo.org 2009-12-16 20:36:19 UTC
*** Bug 7047 has been marked as a duplicate of this bug. ***
Comment 19 bugs.maemo.org@falkensweb.com 2009-12-16 23:54:00 UTC
Hi, I *am* the Flash user community (well, part of it anyway) :-)

Although I can understand 'afraid of pages managing to get users to
accidentally enable the camera', it's difficult to do this accidentally (each
domain generates an in-Flash prompt on each access) and it's not an issue in
other operating systems (i.e. desktop Linux, Mac, Windows) even where those do
not have hardware 'camera in use' lights.

If the N900 is advertised as 'full Flash 9', and it has a camera (or two), it
just seems odd that neither work in the Player.

I understand it may require work from Adobe as well as Nokia, but if it's more
a case of turning it back on than actually writing it, why can't this be done ?

I'm happy to have further discussions about the 'other things' too, of course.
Comment 20 pepitoe 2009-12-17 00:15:16 UTC
On desktop Flash a dialog appears in the Flash content asking for permission to
use the camera on that website, and the permission is not saved permanently
unless you manually go into Flash settings and tick remember.  This seems to
cover privacy enough for me although I don't know if it is working in the same
way on N900.

According to Adobe, Flash 10.1 should be coming to Maemo, hopefully this is at
least being considered for that version.
Comment 21 bugs.maemo.org@falkensweb.com 2009-12-17 11:49:46 UTC
If it doesn't support the devices camera, I think refering to it as 'full
Flash' of either v9 or v10.1 is a bit disingenuous. 
You wouldn't expect with (say) a laptop computer that came with a built in
camera to be unable to use that in Flash...
Comment 22 timeless 2009-12-17 12:11:53 UTC
Guys, this is a bug tracking system. Your comments are not adding value to our
bugs. They're adding noise - This doesn't help anyone fix anything.

If you want to write wishlists, please use another service, there's
http://talk.maemo.org and http://wiki.maemo.org/Brainstorm

If you want to contact managers directly, please use Nokia Care, they aggregate
complaints and deliver reports to managers.

If you want to complain to marketing, please contact

Note that engineers working here are often doing so as a favor to the
community, we're opening up details about our internal (thought) processes
which we would otherwise normally not share at all. If you proceed to complain
in response to information sharing, the natural response is to simply stop
sharing information. That would be a net loss for the maemo.org community. So
please, instead of thinking about yourself or your "own community", please
think about the *Maemo community* before you add comments.
Comment 23 bugs.maemo.org@falkensweb.com 2009-12-17 13:31:46 UTC
Sorry, I thought it would be OK to discuss the reasons for a bug being closed
unfixed here, on the bug, because then it'd be all in one place. 

I'll be on the forums :-)
Comment 24 bugs.maemo.org@falkensweb.com 2010-01-11 20:10:52 UTC
Brainstorm link
please vote for the solution.
Comment 25 Quim Gil nokia 2010-01-12 15:19:30 UTC
Now we can resolve this with the more recent resolution MOVED to Brainstorm.

The scope of bugs.maemo.org are bugs and only very specific and no-brainer
enhancement requests. This report contains a feature request that is too
generic for bugs.maemo.org. Please post this problem and propose your
solution in Maemo Brainstorm instead:

More information: http://wiki.maemo.org/Maemo_brainstorm